Hardware Locality (hwloc): Interoperability with the oneAPI Level Zero interface.

Hardware Locality (hwloc) 2.14.0rc1

Functions
Interoperability with the oneAPI Level Zero interface.

## Functions
int | hwloc_levelzero_get_device_cpuset (hwloc_topology_t topology, ze_device_handle_t device, hwloc_cpuset_t set)
int | hwloc_levelzero_get_sysman_device_cpuset (hwloc_topology_t topology, zes_device_handle_t device, hwloc_cpuset_t set)
hwloc_obj_t | hwloc_levelzero_get_device_osdev (hwloc_topology_t topology, ze_device_handle_t device)
hwloc_obj_t | hwloc_levelzero_get_sysman_device_osdev (hwloc_topology_t topology, zes_device_handle_t device)

## Detailed Description

This interface offers ways to retrieve topology information about devices managed by the Level Zero API, both for main Core devices (ZE API) and the Sysman devices (ZES API).

## Function Documentation

## ◆ hwloc_levelzero_get_device_cpuset()

int hwloc_levelzero_get_device_cpuset | ( | hwloc_topology_t | topology,
|  | ze_device_handle_t | device,
|  | hwloc_cpuset_t | set )
| inline

Get the CPU set of logical processors that are physically close to the Level Zero device `device`.

Store in `set` the CPU-set describing the locality of the Level Zero device `device`.

Topology `topology` and device `device` must match the local machine. The Level Zero library must have been initialized with zeInit(). I/O devices detection and the Level Zero component are not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_levelzero_get_device_osdev().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get the cpuset of the entire topology.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

Note
  zeDevicePciGetPropertiesExt() must be supported, or the entire machine locality will be returned.

## ◆ hwloc_levelzero_get_device_osdev()

hwloc_obj_t hwloc_levelzero_get_device_osdev | ( | hwloc_topology_t | topology,
|  | ze_device_handle_t | device )
| inline

Get the hwloc OS device object corresponding to Level Zero device `device`.

Returns
  The hwloc OS device object that describes the given Level Zero device `device`.
  `NULL` if none could be found.

Topology `topology` and device `dv_ind` must match the local machine. The Level Zero library must have been initialized with zeInit(). I/O devices detection and the Level Zero component must be enabled in the topology. If not, the locality of the object may still be found using hwloc_levelzero_get_device_cpuset().

Note
  If the input ZE device is actually a subdevice, then its parent (root device) is actually translated, i.e. the main hwloc OS device is returned instead of one of its children.
  The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out).
  zeDevicePciGetPropertiesExt() must be supported.

## ◆ hwloc_levelzero_get_sysman_device_cpuset()

int hwloc_levelzero_get_sysman_device_cpuset | ( | hwloc_topology_t | topology,
|  | zes_device_handle_t | device,
|  | hwloc_cpuset_t | set )
| inline

Get the CPU set of logical processors that are physically close to the Level Zero Sysman device `device`.

Store in `set` the CPU-set describing the locality of the Level Zero device `device`.

Topology `topology` and device `device` must match the local machine. The Level Zero library must have been initialized with Sysman enabled with zesInit(). I/O devices detection and the Level Zero component are not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_levelzero_get_device_osdev().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get the cpuset of the entire topology.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

## ◆ hwloc_levelzero_get_sysman_device_osdev()

hwloc_obj_t hwloc_levelzero_get_sysman_device_osdev | ( | hwloc_topology_t | topology,
|  | zes_device_handle_t | device )
| inline

Get the hwloc OS device object corresponding to Level Zero Sysman device `device`.

Returns
  The hwloc OS device object that describes the given Level Zero device `device`.
  `NULL` if none could be found.

Topology `topology` and device `dv_ind` must match the local machine. The Level Zero library must have been initialized with Sysman enabled with zesInit(). I/O devices detection and the Level Zero component must be enabled in the topology. If not, the locality of the object may still be found using hwloc_levelzero_get_device_cpuset().

Note
  If the input ZES device is actually a subdevice, then its parent (root device) is actually translated, i.e. the main hwloc OS device is returned instead of one of its children.
  The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out).